#include <assert.h>
#include <stdio.h>
#include <math.h>

double ** cree_matrice_carree    (int nb_lignes);
void      detruit_matrice_carree (double **matrice);
double ** mult_matrices_carrees (int n, double **m1, double **m2);
double ** matrice_raideur_barre_2D ( double E , double A, double I, double x0[3], double x1[3] )
{
  double s,c,**rotation,**rotationT,**raideur,**raideur2,**temp,L,angle,EAsurL;

  L = sqrt ((x0[0]-x1[0]) * (x0[0]-x1[0]) +
	    (x0[1]-x1[1]) * (x0[1]-x1[1]) +
	    (x0[2]-x1[2]) * (x0[2]-x1[2]) );
  angle = atan2 (x1[1]-x0[1],x1[0]-x0[0]);
  EAsurL = E*A/L;
  s = sin(angle);
  c = cos(angle);

  rotation = cree_matrice_carree( 4 );
  rotationT = cree_matrice_carree( 4 );
  raideur  = cree_matrice_carree( 4 );
  raideur2  = cree_matrice_carree( 4 );

  raideur[0][0] =  EAsurL;
  raideur[0][2] = -EAsurL;
  raideur[2][0] = -EAsurL;
  raideur[2][2] =  EAsurL;
  
  rotation[0][0] = c;
  rotation[0][1] = s;
  rotation[1][0] = -s;
  rotation[1][1] = c;
  rotation[2][2] = c;
  rotation[2][3] = s;
  rotation[3][2] = -s;
  rotation[3][3] = c;
  
  rotationT[0][0] = c;
  rotationT[0][1] = -s;
  rotationT[1][0] = s;
  rotationT[1][1] = c;
  rotationT[2][2] = c;
  rotationT[2][3] = -s;
  rotationT[3][2] = s;
  rotationT[3][3] = c;
  
  temp  =  mult_matrices_carrees ( 4,rotationT,raideur );
  raideur2 = mult_matrices_carrees (4,temp,rotation);

  detruit_matrice_carree (rotation);
  detruit_matrice_carree (rotationT);
  detruit_matrice_carree (raideur);
  detruit_matrice_carree (temp);

  return raideur2;
} 
